#include "building.h"
#include "level.h"
#include "guy.h"
#include "game.h"

#define BP_IN_DARK (0)
#define BP_IN_LIGHT (1)
#define BP_OUT_BRICK (2)
#define BP_OUT_DOOR (3)
#define BP_OUT_WINDOW (4)
#define BP_COUNT (5)

building_t bldg;
KGraphic *bldgpix[BP_COUNT],*sidewalk;

void Building_Init(void)
{
	char fname[BP_COUNT][24]={"gfx\\inside_dark.png",
							  "gfx\\inside_light.png",
							  "gfx\\block_brick.png",
							  "gfx\\block_door.png",
							  "gfx\\block_window.png"};
	int i;

	for(i=0;i<BP_COUNT;i++)
	{
		bldgpix[i]=new KGraphic;
		bldgpix[i]->loadPicture(KMiscTools::makeFilePath(fname[i]));
	}
	sidewalk=new KGraphic;
	sidewalk->loadPicture(KMiscTools::makeFilePath("gfx\\sidewalk.png"));

	SetupLevel(curLevel);
}

void Building_Exit(void)
{
	int i;

	for(i=0;i<BP_COUNT;i++)
		delete bldgpix[i];

	delete sidewalk;
}

void Building_Render(void)
{
	int i,j;

	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			if(bldg.type[i+j*BLDG_WIDTH]!=BLDG_EMPTY)
			{
				switch(bldg.lit[i+j*BLDG_WIDTH])
				{
					case 0:
						bldgpix[BP_IN_DARK]->blitRect(0,0,BLDG_TILEX,BLDG_TILEY,(BLDG_X+BLDG_TILEX*i),(BLDG_Y+BLDG_TILEY*j),false,false);
						break;
					case 1:
						bldgpix[BP_IN_LIGHT]->blitRect(0,0,BLDG_TILEX,BLDG_TILEY,(BLDG_X+BLDG_TILEX*i),(BLDG_Y+BLDG_TILEY*j),false,false);
						break;
				}
			}
		}
	Guys_Render();
	sidewalk->blitRect(0,0,800,86,0,600-86,false,false);
	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			if(bldg.type[i+j*BLDG_WIDTH]!=BLDG_EMPTY)
			{
				switch(bldg.type[i+j*BLDG_WIDTH])
				{
					case BLDG_BRICK:
						bldgpix[BP_OUT_BRICK]->blitRect(0,0,BLDG_TILEX,BLDG_TILEY,(BLDG_X+BLDG_TILEX*i),(BLDG_Y+BLDG_TILEY*j),false,false);
						break;
					case BLDG_WINDOW:
						bldgpix[BP_OUT_WINDOW]->blitAlphaRect(0,0,BLDG_TILEX,BLDG_TILEY,(BLDG_X+BLDG_TILEX*i),(BLDG_Y+BLDG_TILEY*j),false,false);
						break;
					case BLDG_DOOR:
						bldgpix[BP_OUT_DOOR]->blitRect(0,0,BLDG_TILEX,BLDG_TILEY,(BLDG_X+BLDG_TILEX*i),(BLDG_Y+BLDG_TILEY*j),false,false);
						break;
				}
			}
		}
}
