#include "fusebox.h"
#include "particle.h"

fuseBox_t fuseBox;
static KGraphic *fuseBoxPic,*fusePic,*clipPic;

void FuseBox_Init(void)
{
	int i,j;

	fuseBoxPic=new KGraphic;
	fuseBoxPic->loadPicture(KMiscTools::makeFilePath("gfx\\fusebox.png"));
	fusePic=new KGraphic;
	fusePic->loadPicture(KMiscTools::makeFilePath("gfx\\fuse.png"));
	clipPic=new KGraphic;
	clipPic->loadPicture(KMiscTools::makeFilePath("gfx\\fuse_clip.png"));

	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			switch(bldg.type[i+j*BLDG_WIDTH])
			{
				case BLDG_EMPTY:
				case BLDG_BRICK:
				case BLDG_DOOR:
					fuseBox.state[i+j*BLDG_WIDTH]=FUSE_NONE;
					break;
				case BLDG_WINDOW:
					if(bldg.lit[i+j*BLDG_WIDTH])
						fuseBox.state[i+j*BLDG_WIDTH]=FUSE_ON;
					else
						fuseBox.state[i+j*BLDG_WIDTH]=FUSE_OFF;
					break;
			}
		}
}

void FuseBox_Exit(void)
{
	delete fuseBoxPic;
	delete fusePic;
	delete clipPic;
}

void FuseBox_Render(void)
{
	int i,j;

	fuseBoxPic->blitAlphaRect(0,0,239,174,800-239,600-174,false,false);
	
	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			switch(fuseBox.state[i+j*BLDG_WIDTH])
			{
				case FUSE_ON:
					fusePic->blitAlphaRect(0,0,26,31,(short)(FUSE_X+FUSE_OFFX*i+FUSE_OFFYX*j),(short)(FUSE_Y+FUSE_OFFY*j-2.0f),false,false);
					break;
				case FUSE_OFF:
					clipPic->blitAlphaRect(0,0,26,28,(short)(FUSE_X+FUSE_OFFX*i+FUSE_OFFYX*j),(short)(FUSE_Y+FUSE_OFFY*j),false,false);
					break;
			}
		}
}

void SparkFuse(byte fuse)
{
	Particle_Effect(PART_SPARK,(FUSE_X+FUSE_OFFX*(fuse%BLDG_WIDTH)+FUSE_OFFX/2+FUSE_OFFYX*(fuse/BLDG_WIDTH)),
							   (FUSE_Y+FUSE_OFFY*(fuse/BLDG_WIDTH)+FUSE_OFFY/2));
}

byte FuseClicked(int x,int y)
{
	int i,j;

	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			if(x>=(int)(FUSE_X+FUSE_OFFX*i+FUSE_OFFYX*j) && y>=(int)(FUSE_Y+FUSE_OFFY*j) &&
			   x<(int)(FUSE_X+FUSE_OFFX*(i+1)+FUSE_OFFYX*j) && y<(int)(FUSE_Y+FUSE_OFFY*(j+1)))
			   return (i+j*BLDG_WIDTH);
		}

	return 255;
}