#ifndef FUSEBOX_H
#define FUSEBOX_H

#include "basics.h"
#include "building.h"

#define FUSE_NONE	(0)
#define FUSE_OFF	(1)
#define FUSE_ON		(2)

#define FUSE_X		((float)(800-239+20))
#define FUSE_Y		((float)(600-174+20))
#define FUSE_OFFX	(27.0f)
#define FUSE_OFFY	(26.0f)
#define FUSE_OFFYX	(-0.5f)
// FUSE_OFFYX is how much it adds to the X of each fuse as it moves down the rows, to match the 3D angle

typedef struct fuseBox_t
{
	byte state[BLDG_WIDTH*BLDG_HEIGHT];
} fuseBox_t;

extern fuseBox_t fuseBox;

void FuseBox_Init(void);
void FuseBox_Exit(void);
void FuseBox_Render(void);

byte FuseClicked(int x,int y);
void SparkFuse(byte fuse);

#endif