#ifndef GUY_H
#define GUY_H

#include "basics.h"

#define MAX_GUYS	(128)

#define GUY_NONE	(0)
#define GUY_GREEN	(1)	// the guy in green pajamas
#define GUY_ZOMBIE	(2)
#define GUY_KINGCHUD (3)

#define GS_THINKING	(0)
#define GS_MOVING	(1)
#define GS_DYING	(2)

#define GUY_CENTERX	(42.0f)
#define GUY_CENTERY (66.0f)

#define MAX_LIFE	(60)

typedef struct guy_t
{
	byte king;
	byte type;
	byte cell,toCell;	// which building cell is he in
	float x,y,dx,dy,stepy,stepdy;	// stepy is an offset to regular Y for a stepping animation
	byte state,anim,animDelay;	// which state he's in, which animation frame he's on, delay until next frame
	word thinkDelay;	// countdown to next move decision
	byte life;			// zombie stands in light too long, this counts down until he dies
} guy_t;

extern guy_t guys[MAX_GUYS];
extern byte zombieCount,peopleCount,zombiesSlain,peopleStart;

void Guys_Init(void);
void Guys_Exit(void);
void Guys_Update(void);
void Guys_Render(void);
void Guys_Add(byte cell,byte type);

void CallZombie(void);

#endif