#include "level.h"
#include "guy.h"

level_t levelDef[NUM_LEVELS]={
	{"DEAD EASY",
	 "........",
	 "........",
	 "........",
	 "........",
	 "...pW...",
	 "...wD...",
	 GOAL_SAVE,	// goal
	 1,		// goal number
	 3,		// zombies
	 60*5,	// zombieRate
	 60,	// zombieSpeed
	 60,	// personSpeed
	 60*20,	// time
	},
	{"HEAD EM OFF",
	 "........",
	 "........",
	 "........",
	 "..Wwpp..",
	 "..wpWb..",
	 "..bwDw..",
	 GOAL_SAVE,	// goal
	 2,		// goal number
	 5,		// zombies
	 60*3,	// zombieRate
	 60,	// zombieSpeed
	 60,	// personSpeed
	 60*30,	// time
	},
	{"CHUD BBQ",
	 "........",
	 "........",
	 "........",
	 "..Wwww..",
	 "..wwWw..",
	 "..WwDw..",
	 GOAL_KILL,	// goal
	 4,		// goal number
	 10,	// zombies
	 60*2,	// zombieRate
	 30,	// zombieSpeed
	 60,	// personSpeed
	 60*60,	// time
	},
	{"STILL CHEATABLE",
	 "........",
	 "........",
	 ".pPwwPw.",
	 ".wWppww.",
	 ".Wwwwpw.",
	 ".bWwDwb.",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 10,	// zombies
	 60*5,	// zombieRate
	 60,	// zombieSpeed
	 30,	// personSpeed
	 60*60,	// time
	},
	{"THE REAL TRICK",
	 "........",
	 "........",
	 ".pPwwPw.",
	 ".wWppww.",
	 ".Wwwwpw.",
	 ".wWDDww.",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 10,	// zombies
	 60*5,	// zombieRate
	 60,	// zombieSpeed
	 30,	// personSpeed
	 60*60,	// time
	},
	{"NO ESCAPE",
	 "........",
	 ".bbWbbb.",
	 ".pPwwPw.",
	 ".wWppww.",
	 ".Wwwwpw.",
	 ".wWwDwp.",
	 GOAL_SAVE, // goal
	 7,		// goal number
	 10,	// zombies
	 60*5,	// zombieRate
	 60,	// zombieSpeed
	 30,	// personSpeed
	 60*60,	// time
	},
	{"BBQ2:ELECTRIC BOOGALOO",
	 "...WW...",
	 "..WwwW..",
	 ".wwwwww.",
	 ".wwwwww.",
	 ".wwwwww.",
	 ".wwDDww.",
	 GOAL_KILL, // goal
	 10,	// goal number
	 30,	// zombies
	 60*1,	// zombieRate
	 10,	// zombieSpeed
	 30,	// personSpeed
	 60*60,	// time
	},
	{"LIGHT BRIGHT",
	 ".WWDDWW.",
	 "WWWDDWWW",
	 "pwpDDpwp",
	 "pwpDDpwp",
	 "pwpDDpwp",
	 "pwpDDpwp",
	 GOAL_SAVE, //goal
	 12,	// goal number
	 7,		// zombies
	 60*6,	// zombieRate
	 50,	// zombieSpeed
	 30,	// personSpeed
	 60*60,	// time
	},
	{"DOUBLE TROUBLE",
	 "ppp..ppp",
	 "www..www",
	 "wWw..wWw",
	 "www..www",
	 "wWw..wWw",
	 "wwwDDwww",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 15,	// zombies
	 60*4,	// zombieRate
	 40,	// zombieSpeed
	 10,	// personSpeed
	 60*60,	// time
	},
	{"TOWER OF PISA",
	 "....wWw.",
	 "...wpw..",
	 "..wwwp..",
	 ".pwWw...",
	 ".wpww...",
	 "wwDw....",
	 GOAL_SAVE, // goal
	 3,		// goal number
	 15,	// zombies
	 60*4,	// zombieRate
	 60,	// zombieSpeed
	 1,		// personSpeed
	 60*40,	// time
	},
	{"HAIL TO THE KING",
	 "..W..W..",
	 "..pwwp..",
	 "..wppw..",
	 ".pwWWwp.",
	 ".wwwwww.",
	 "bwwDKwwb",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 3,		// zombies
	 60*5,	// zombieRate
	 40,	// zombieSpeed
	 20,	// personSpeed
	 60*40,	// time
	},
	{"CHUD BUFFET",
	 "pppppppp",
	 "ppPppPpp",
	 "PppPPppp",
	 "ppPppPpp",
	 "pppppppp",
	 "pppppppp",
	 GOAL_SAVE, // goal
	 20,	// goal number
	 20,	// zombies
	 60*2,	// zombieRate
	 40,	// zombieSpeed
	 20,	// personSpeed
	 60*60,	// time
	},
	{"RING KING",
	 ".pwwwwp.",
	 "pwwwwWwp",
	 "www..www",
	 "www..www",
	 "pwWwwWwp",
	 ".pwkwwp.",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 3,		// zombies
	 60*5,	// zombieRate
	 40,	// zombieSpeed
	 20,	// personSpeed
	 60*40,	// time
	},
	{"A REAL SCORCHER",
	 "pppppppp",
	 "ppPppPpp",
	 "PppPPppP",
	 "ppPppPpp",
	 "PppppppP",
	 "pppppppp",
	 GOAL_KILL, // goal
	 40,	// goal number
	 200,	// zombies
	 10,	// zombieRate
	 2,		// zombieSpeed
	 20,	// personSpeed
	 60*80,	// time
	},
	{"A KING THING",
	 "pwwppwwp",
	 "wpwwwwpw",
	 "pwpwwpwp",
	 "wpWWWWpw",
	 "wwwwwwww",
	 "wwkKKkww",
	 GOAL_SAVE, // goal
	 6,		// goal number
	 0,		// zombies
	 60*3,	// zombieRate
	 60,	// zombieSpeed
	 20,	// personSpeed
	 60*60,	// time
	},
	{"THE BIG ONE",
	 "wwwwwwww",
	 "wwwppwww",
	 "wwWbbWww",
	 "wwpWWpww",
	 "wpwwwwpw",
	 "wwwDDwwb",
	 GOAL_SAVE, // goal
	 5,		// goal number
	 20,	// zombies
	 60*3,	// zombieRate
	 30,	// zombieSpeed
	 50,	// personSpeed
	 60*60,	// time
	},
	{"MANO A MANO",
	 "wwwwwwww",
	 "wwwwwwww",
	 "wwwpPwww",
	 "wwwwwwww",
	 "wwwwwwww",
	 "wwwDKwww",
	 GOAL_SAVE, // goal
	 2,		// goal number
	 0,		// zombies
	 60*3,	// zombieRate
	 60,	// zombieSpeed
	 50,	// personSpeed
	 60*60,	// time
	},
	{"TIGHT QUARTERS",
	 "bbbbbbbb",
	 "bpwwwwpb",
	 "bwbwwbwb",
	 "bpwWWwpb",
	 "bwbwwbwb",
	 "bpwwwwpb",
	 GOAL_SAVE, // goal
	 4,		// goal number
	 7,		// zombies
	 60*7,	// zombieRate
	 30,	// zombieSpeed
	 20,	// personSpeed
	 60*60,	// time
	},
};

byte levelAvailable[NUM_LEVELS];

void LoadConfig(void)
{
	FILE *f;
	byte b;

	f=fopen(KMiscTools::makeFilePath("save.dat"),"rb");
	if(!f)
	{
		levelAvailable[0]=1;
		for(b=1;b<NUM_LEVELS;b++)
			levelAvailable[b]=0;
	}
	else
	{
		fread(levelAvailable,sizeof(byte),NUM_LEVELS,f);
		fclose(f);
	}
}

void SaveConfig(void)
{
	FILE *f;
	
	f=fopen(KMiscTools::makeFilePath("save.dat"),"wb");
	fwrite(levelAvailable,sizeof(byte),NUM_LEVELS,f);
	fclose(f);
}

void SetupLevel(byte level)
{
	int i,j;

	for(i=0;i<BLDG_WIDTH;i++)
		for(j=0;j<BLDG_HEIGHT;j++)
		{
			switch(levelDef[level].map[j][i])
			{
				case '.':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_EMPTY;
					break;
				case 'p':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_WINDOW;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					Guys_Add(i+j*BLDG_WIDTH,GUY_GREEN);
					break;
				case 'P':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_WINDOW;
					bldg.lit[i+j*BLDG_WIDTH]=1;
					Guys_Add(i+j*BLDG_WIDTH,GUY_GREEN);
					break;
				case 'w':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_WINDOW;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					break;
				case 'W':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_WINDOW;
					bldg.lit[i+j*BLDG_WIDTH]=1;
					break;
				case 'D':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_DOOR;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					break;
				case 'K':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_DOOR;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					Guys_Add(i+j*BLDG_WIDTH,GUY_KINGCHUD);
					break;
				case 'k':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_WINDOW;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					Guys_Add(i+j*BLDG_WIDTH,GUY_KINGCHUD);
					break;
				case 'b':
					bldg.type[i+j*BLDG_WIDTH]=BLDG_BRICK;
					bldg.lit[i+j*BLDG_WIDTH]=0;
					break;				
			}
		}

	levelAvailable[level]=1;
	// fill in the invisible extra row on the bottom, where monsters begin their life
	for(i=0;i<BLDG_WIDTH;i++)
	{
		bldg.type[i+BLDG_HEIGHT*BLDG_WIDTH]=BLDG_DOOR;
		bldg.lit[i+BLDG_HEIGHT*BLDG_WIDTH]=0;
	}
}
