#ifndef LEVEL_H
#define LEVEL_H

#include "basics.h"
#include "building.h"

#define GOAL_SAVE	(0)	// survive the night with at least N people
#define GOAL_KILL	(1)	// kill N zombies

#define NUM_LEVELS	(18)

typedef struct level_t
{
	char name[32];
	char map[BLDG_HEIGHT][BLDG_WIDTH+1];
	byte goal;
	byte goalVal;
	byte zombies;
	word zombieRate;	// how many frames between when each new zombie is released
	byte zombieSpeed;	// how many ticks zombies wait before making a new move
	byte personSpeed;	// how many ticks people wait before (maybe) making a new move
	word time;	// 60 ticks in a second, maximum night length is 60*60*2, 2 minutes
} level_t;

extern level_t levelDef[NUM_LEVELS];
extern byte levelAvailable[NUM_LEVELS];

void SetupLevel(byte level);
void LoadConfig(void);
void SaveConfig(void);

#endif