#include "basics.h"
#include "building.h"
#include "menu.h"
#include "game.h"
#include "sound.h"
#include "level.h"

// LD48 #6 Light & Darkness
// Habitat For Horror
// by Mike Hommel

KWindow	*gameWindow=NULL;

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPreInst,LPSTR lpszCmdLine,int nCmdShow)
{
	gameWindow=new KWindow;

	if(gameWindow==NULL)		
		return 0;
	
	if(gameWindow->createGameWindow(XRES,YRES,-1,true,"Habitat For Horror")==false)
	{
		delete gameWindow;
		return 0;
	}

	if(KWindow::getAccelerationCap()==FALSE)
	{
		KMiscTools::launchURL("http://hamumu.com/opengl.php?game=Habitat%20For%20Horror");
		return 0;
	}

	KInput::hidePointer();
	KMiscTools::initMiscTools();

	KGraphic::setGraphicQuality(true);
	KGraphic::setClearColor(0,0,0,1);

	LoadConfig();
	curLevel=0;
	for(int i=0;i<NUM_LEVELS;i++)
		if(levelAvailable[i])
			curLevel=i;

	Sound_Init();
	byte b=MENU_RUNNING;
	while(b!=MENU_EXIT)
	{
		b=Menu_Run();
		switch(b)
		{
			case MENU_PLAY:
				b=2;
				while(b!=0)
				{
					b=Game_Run();
					if(b==2)
						curLevel++;
					if(curLevel>=NUM_LEVELS)
					{
						b=0;
						curLevel=0;
					}
				}
				break;
		}
	}
	Sound_Exit();
	SaveConfig();
	delete gameWindow;
	return 0;
}
