#ifndef PARTICLE_H
#define PARTICLE_H

#include "basics.h"

#define MAX_PARTICLES	(256)

#define PART_NONE	(0)
#define PART_CHOMP	(1)
#define PART_SMOKE	(2)
#define PART_SPARK	(3)

typedef struct particle_t
{
	byte type;
	float x,y,dx,dy;
	byte life;
	float scale,rot,blend;
} particle_t;

void Particle_Init(void);
void Particle_Exit(void);
void Particle_Update(void);
void Particle_Render(void);

void Particle_Effect(byte type,float x,float y);

float RandRange(float min,float max);

#endif