#include "sound.h"

KSound *snd[MAX_SOUNDS];
char sndName[MAX_SOUNDS][32]={
	"snd\\chomp.wav",
	"snd\\smoke.ogg",
	"snd\\torched.wav",
	"snd\\win.wav",
	"snd\\lose.wav",
	"snd\\fuse_get.wav",
	"snd\\fuse_put.wav",
};
KSound *music;
byte musicOn;

void Sound_Init(void)
{
	int i;

	for(i=0;i<MAX_SOUNDS;i++)
	{
		snd[i]=new KSound;
		snd[i]->loadSample(KMiscTools::makeFilePath(sndName[i]),100,false,4);
	}
	music=new KSound;
	music->loadStream(KMiscTools::makeFilePath("snd\\chudsong.ogg"));
	music->playStream(true);
	musicOn=1;
}

void Sound_Exit(void)
{
	int i;
	for(i=0;i<MAX_SOUNDS;i++)
		delete snd[i];
}

void Sound_Play(byte sndNum)
{
	if(sndNum>=MAX_SOUNDS)
		return;

	snd[sndNum]->playSample();
}

void ToggleMusic(void)
{
	musicOn=1-musicOn;

	if(musicOn)
		music->playStream(true);
	else
		music->stopStream();
}

